<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <title>Order Detail</title>
</head>

<body onload="onPageLoading()">
    <div class="container-fluid pt-4">
        <form action="" id="order-form">
            <h2 class="text-center pb-3">Chi tiết đơn hàng</h2>
            <!-- 1 line -->
            <div class="row justify-content-center pl-5 pr-5">
                <div class="col-6 form-group row">
                    <label for="inp-order-code" class="col-4 col-form-label text-right">Order Code</label>
                    <div class="col-8">
                        <input type="text" class="form-control" id="inp-order-code">
                    </div>
                </div>
                <div class="col-6 form-group row">
                    <label for="select-kich-co" class="col-4 col-form-label text-right">Cỡ combo</label>
                    <div class="col-8">
                        <select id="select-kich-co" class="form-control">
                            <option value="0">Chọn Cỡ Combo (Combo size)</option>
                        </select>
                    </div>
                </div>
            </div>
            <!-- 1 line -->
            <div class="row justify-content-center pl-5 pr-5">
                <div class="col-6 form-group row">
                    <label for="inp-duong-kinh-pizza" class="col-4 col-form-label text-right">Đường kính pizza</label>
                    <div class="col-8">
                        <input type="text" class="form-control" id="inp-duong-kinh-pizza">
                    </div>
                </div>
                <div class="col-6 form-group row">
                    <label for="inp-suon-nuong" class="col-4 col-form-label text-right">Sườn nướng(miếng)</label>
                    <div class="col-8">
                        <input type="text" class="form-control" id="inp-suon-nuong">
                    </div>
                </div>
            </div>
            <!-- 1 line -->
            <div class="row justify-content-center pl-5 pr-5">
                <div class="col-6 form-group row">
                    <label for="select-do-uong" class="col-4 col-form-label text-right">Đồ uống</label>
                    <div class="col-8">
                        <select id="select-do-uong" class="form-control">
                            <option value="0">Chọn đồ uống</option>
                        </select>
                    </div>
                </div>
                <div class="col-6 form-group row">
                    <label for="inp-so-luong-nuoc-uong" class="col-4 col-form-label text-right">Số lượng nước
                        uống</label>
                    <div class="col-8">
                        <input type="text" class="form-control" id="inp-so-luong-nuoc-uong">
                    </div>
                </div>
            </div>
            <!-- 1 line -->
            <div class="row justify-content-center pl-5 pr-5">
                <div class="col-6 form-group row">
                    <label for="inp-voucher-id" class="col-4 col-form-label text-right">Voucher ID</label>
                    <div class="col-8">
                        <input type="text" class="form-control" id="inp-voucher-id">
                    </div>
                </div>
                <div class="col-6 form-group row">
                    <label for="select-loai-pizza" class="col-4 col-form-label text-right">Loại pizza</label>
                    <div class="col-8">
                        <select id="select-loai-pizza" class="form-control">
                            <option value="0">Chọn loại pizza</option>
                        </select>
                    </div>
                </div>
            </div>
            <!-- 1 line -->
            <div class="row justify-content-center pl-5 pr-5">
                <div class="col-6 form-group row">
                    <label for="inp-salad" class="col-4 col-form-label text-right">Salad</label>
                    <div class="col-8">
                        <input type="text" class="form-control" id="inp-salad">
                    </div>
                </div>
                <div class="col-6 form-group row">
                    <label for="inp-thanh-tien" class="col-4 col-form-label text-right">Thành tiền</label>
                    <div class="col-8">
                        <input type="text" class="form-control" id="inp-thanh-tien">
                    </div>
                </div>
            </div>
            <!-- 1 line -->
            <div class="row justify-content-center pl-5 pr-5">
                <div class="col-6 form-group row">
                    <label for="inp-giam-gia" class="col-4 col-form-label text-right">Giảm giá</label>
                    <div class="col-8">
                        <input type="text" class="form-control" id="inp-giam-gia">
                    </div>
                </div>
                <div class="col-6 form-group row">
                    <label for="inp-ho-va-ten" class="col-4 col-form-label text-right">Họ và tên</label>
                    <div class="col-8">
                        <input type="text" class="form-control" id="inp-ho-va-ten">
                    </div>
                </div>
            </div>
            <!-- 1 line -->
            <div class="row justify-content-center pl-5 pr-5">
                <div class="col-6 form-group row">
                    <label for="inp-email" class="col-4 col-form-label text-right">Email</label>
                    <div class="col-8">
                        <input type="email" class="form-control" id="inp-email">
                    </div>
                </div>
                <div class="col-6 form-group row">
                    <label for="inp-so-dien-thoai" class="col-4 col-form-label text-right">Số điện thoại</label>
                    <div class="col-8">
                        <input type="text" class="form-control" id="inp-so-dien-thoai">
                    </div>
                </div>
            </div>
            <!-- 1 line -->
            <div class="row justify-content-center pl-5 pr-5">
                <div class="col-6 form-group row">
                    <label for="inp-dia-chi" class="col-4 col-form-label text-right">Địa chỉ</label>
                    <div class="col-8">
                        <input type="text" class="form-control" id="inp-dia-chi">
                    </div>
                </div>
                <div class="col-6 form-group row">
                    <label for="inp-loi-nhan" class="col-4 col-form-label text-right">Lời nhắn</label>
                    <div class="col-8">
                        <input type="text" class="form-control" id="inp-loi-nhan">
                    </div>
                </div>
            </div>
            <!-- 1 line -->
            <div class="row justify-content-center pl-5 pr-5">
                <div class="col-6 form-group row">
                    <label for="select-trang-thai" class="col-4 col-form-label text-right">Trạng thái đơn hàng</label>
                    <div class="col-8">
                        <select id="select-trang-thai" class="form-control">
                            <option value="0">Trạng thái</option>
                        </select>
                    </div>
                </div>
                <div class="col-6 form-group row">
                    <label for="inp-ngay-tao-don" class="col-4 col-form-label text-right">Ngày tạo đơn</label>
                    <div class="col-8">
                        <input type="text" class="form-control" id="inp-ngay-tao-don">
                    </div>
                </div>
            </div>
            <!-- 1 line -->
            <div class="row justify-content-center pl-5 pr-5">
                <div class="col-6 form-group row">
                    <label for="inp-ngay-cap-nhat" class="col-4 col-form-label text-right">Ngày cập nhật</label>
                    <div class="col-8">
                        <input type="text" class="form-control" id="inp-ngay-cap-nhat">
                    </div>
                </div>
                <div class="col-6 form-group row"> </div>
            </div>
            <!-- 1 line -->
            <div class="row justify-content-center pl-5 pr-5">
                <div class="col-6 form-group row d-flex justify-content-center">
                    <div class="btn-group">
                        <button type="submit" class="btn btn-success ml-2 mr-1">Confirm</button>
                        <button type="button" class="btn btn-primary ml-1 mr-2" id="btn-cancel">Cancel</button>
                    </div>
                </div>
                <div class="col-6 form-group row"> </div>
            </div>
        </form>
    </div>
</body>

<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_CREATE_SUCCESS = 201; // status 201 - tạo thành công
    const gREQUEST_DELETE_SUCCESS = 204; // status 204 - Xóa thành công
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
    //biến toàn cục Order
    var gOrder = {
        id: "",
        orderCode: "",
        kichCo: "",
        duongKinh: "",
        suon: 0,
        salad: "",
        loaiPizza: 0,
        idVoucher: "",
        thanhTien: 0,
        giamGia: 0,
        idLoaiNuocUong: "",
        soLuongNuoc: 0,
        hoTen: "",
        email: "",
        soDienThoai: "",
        diaChi: "",
        loiNhan: "",
        trangThai: "",
        ngayTao: 0,
        ngayCapNhat: 0
    }
    var gOrderFormElement = document.getElementById("order-form");
    var gCancelButtonElement = document.getElementById("btn-cancel");
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    gOrderFormElement.addEventListener("submit", function (paramEvent) {
        //Loại bỏ mặc định của submitform
        paramEvent.preventDefault();
        //Không cần thu thập và kiểm tra dữ liệu, khi tải trang đã lưu đối tượng vào gOrder
        console.log("Confirm: " + gOrder.id);
        var vXmlConfirmOrder = new XMLHttpRequest();
        callApiConfirmOrder(gOrder, vXmlConfirmOrder);
        thongBaoConfirmOrder(vXmlConfirmOrder);
    });

    gCancelButtonElement.addEventListener("click",function onBtnCancelClick() {
        //Không cần thu thập và kiểm tra dữ liệu, khi tải trang đã lưu đối tượng vào gOrder
        console.log("Cancel: " + gOrder.id);
        var vXmlCancelmOrder = new XMLHttpRequest();
        callApiCancelOrder(gOrder, vXmlCancelmOrder);
        thongBaoCancelOrder(vXmlCancelmOrder);
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        thuThapDuLieuTaiTrang(gOrder);
        var vDuLieuTaiTrangHopLe = kiemTraDuLieuTaiTrang(gOrder);
        if (vDuLieuTaiTrangHopLe) {
            var vXmlHttpGetOrderByOrderCode = new XMLHttpRequest();
            callAPiGetOrderByOrderCode(gOrder, vXmlHttpGetOrderByOrderCode);
            hienThiOrderLenWeb(vXmlHttpGetOrderByOrderCode);
        }
        else {
            backToOrderListView();
        }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function backToOrderListView() {
        window.location.href = "indexListView.html";
    }

    function thuThapDuLieuTaiTrang(paramOrder) {
        // get data from query string
        var vUrlString = window.location.href; //đường đẫn gọi đến trang
        var vUrl = new URL(vUrlString);
        // get parameters
        paramOrder.id = vUrl.searchParams.get("id");
        paramOrder.orderCode = vUrl.searchParams.get("orderCode");
    }

    function kiemTraDuLieuTaiTrang(paramOrder) {
        if (paramOrder.id == "" || paramOrder.id == null) {
            alert("Query string không lấy được dữ liệu");
            return false;
        }
        if (paramOrder.orderCode == "" || paramOrder.orderCode == null) {
            alert("Query string không lấy được dữ liệu");
            return false;
        }
        return true;
    }

    function callAPiGetOrderByOrderCode(paramOrder, paramXmlGetOrder) {
        paramXmlGetOrder.open("GET", gBASE_URL + "/" + paramOrder.orderCode, true);
        paramXmlGetOrder.send();
    }

    function hienThiOrderLenWeb(paramXmlGetOrder) {
        paramXmlGetOrder.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log(paramXmlGetOrder.responseText);
                    var vOrderResponse = JSON.parse(paramXmlGetOrder.responseText);
                    // get elements
                    var vOrderCodeInputElement = document.getElementById("inp-order-code");
                    var vKichCoSelectElement = document.getElementById("select-kich-co");
                    var vDuongKinhPizzaInputElement = document.getElementById("inp-duong-kinh-pizza");
                    var vSuonNuongInputElement = document.getElementById("inp-suon-nuong");
                    var vDoUongSelectElement = document.getElementById("select-do-uong");
                    var vSoLuongNuocUongInputElement = document.getElementById("inp-so-luong-nuoc-uong");
                    var vVoucherIDInputElement = document.getElementById("inp-voucher-id");
                    var vLoaiPizzaSelectElement = document.getElementById("select-loai-pizza");
                    var vSaladInputElement = document.getElementById("inp-salad");
                    var vThanhTienInputElement = document.getElementById("inp-thanh-tien");
                    var vGiamGiaInputElement = document.getElementById("inp-giam-gia");
                    var vHoVaTenInputElement = document.getElementById("inp-ho-va-ten");
                    var vEmailInputElement = document.getElementById("inp-email");
                    var vSoDienThoaiInputElement = document.getElementById("inp-so-dien-thoai");
                    var vDiaChiInputElement = document.getElementById("inp-dia-chi");
                    var vLoiNhanInputElement = document.getElementById("inp-loi-nhan");
                    var vTrangThaiSelectElement = document.getElementById("select-trang-thai");
                    var vNgayTaoDonInputElement = document.getElementById("inp-ngay-tao-don");
                    var vNgayCapNhatInputElement = document.getElementById("inp-ngay-cap-nhat");
                    //change value
                    vOrderCodeInputElement.value = vOrderResponse.orderCode;
                    vKichCoSelectElement.options[vKichCoSelectElement.selectedIndex].text = vOrderResponse.kichCo;
                    vDuongKinhPizzaInputElement.value = vOrderResponse.duongKinh;
                    vSuonNuongInputElement.value = vOrderResponse.suon;
                    vDoUongSelectElement.options[vDoUongSelectElement.selectedIndex].text = vOrderResponse.idLoaiNuocUong;
                    vSoLuongNuocUongInputElement.value = vOrderResponse.soLuongNuoc;
                    vVoucherIDInputElement.value = vOrderResponse.idVourcher;
                    vLoaiPizzaSelectElement.options[vLoaiPizzaSelectElement.selectedIndex].text = vOrderResponse.loaiPizza;
                    vSaladInputElement.value = vOrderResponse.salad;
                    vThanhTienInputElement.value = vOrderResponse.thanhTien;
                    vGiamGiaInputElement.value = vOrderResponse.giamGia;
                    vHoVaTenInputElement.value = vOrderResponse.hoTen;
                    vEmailInputElement.value = vOrderResponse.email;
                    vDiaChiInputElement.value = vOrderResponse.diaChi;
                    vLoiNhanInputElement.value = vOrderResponse.loiNhan;
                    vTrangThaiSelectElement.options[vTrangThaiSelectElement.selectedIndex].text = vOrderResponse.trangThai;
                    vNgayTaoDonInputElement.value = vOrderResponse.ngayTao;
                    vNgayCapNhatInputElement.value = vOrderResponse.ngayCapNhat;
                }
            }
    }

    function callApiConfirmOrder(paramOrder, paramXmlConfirmOrder) {
        var vObjectRequest = {
            trangThai: "confirmed" //3 trạng thái: open, confirmed, cancel
        }
        paramXmlConfirmOrder.open("PUT", gBASE_URL + "/" + paramOrder.id);
        paramXmlConfirmOrder.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
        paramXmlConfirmOrder.send(JSON.stringify(vObjectRequest));
    }

    function thongBaoConfirmOrder(paramXmlConfirmOrder) {
        paramXmlConfirmOrder.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK) {
                    if (this.status == gREQUEST_STATUS_OK) {
                        console.log(paramXmlConfirmOrder.responseText);
                        alert("Confirm đơn hàng thành công!");
                        backToOrderListView();
                    }
                    else {
                        alert("Confirm đơn hàng thất bại!");
                        backToOrderListView();
                    }
                }
            }
    }

    function callApiCancelOrder(paramOrder, paramXmlCancelOrder) {
        var vObjectRequest = {
            trangThai: "cancel" //3 trạng thái: open, confirmed, cancel
        }
        paramXmlCancelOrder.open("PUT", gBASE_URL + "/" + paramOrder.id);
        paramXmlCancelOrder.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
        paramXmlCancelOrder.send(JSON.stringify(vObjectRequest));
    }

    function thongBaoCancelOrder(paramXmlCancelOrder) {
        paramXmlCancelOrder.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK) {
                    if (this.status == gREQUEST_STATUS_OK) {
                        console.log(paramXmlCancelOrder.responseText);
                        alert("Cancel đơn hàng thành công!");
                        backToOrderListView();
                    }
                    else {
                        alert("Cancel đơn hàng thất bại!");
                        backToOrderListView();
                    }
                }
            }
    }
</script>

</html>